#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_outfile=Stadion-Uhr.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=Stadion-Uhr
#AutoIt3Wrapper_Res_Fileversion=1.1.0.0
#AutoIt3Wrapper_Res_LegalCopyright=by Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <StaticConstants.au3>
#include <GUIConstantsEx.au3>
Opt('GUIOnEventMode', 1)

Global $sStatus = 'Start', $iTimer, $iTimerPause

$hGui = GUICreate('Stadion-Uhr v1.1    ' & Chr(169) & ' by Oscar (www.autoit.de)', 640, 430, -1, -1, Default, 0x02000000)
GUISetOnEvent($GUI_EVENT_CLOSE, '_End')
GUISetBkColor(0xFFFFCC)
GUISetIcon('shell32.dll', 21)

$sDate = @MDAY & '.' & @MON & '.' & @YEAR
$hDate = GUICtrlCreateLabel($sDate, 500, 10, 130, 25, $SS_RIGHT)
GUICtrlSetFont(-1, 16, 800, 0, 'Tahoma')
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

$hTime = GUICtrlCreateLabel(@HOUR & ':' & @MIN & ':' & @SEC, 150, 30, 340, 80, $SS_CENTER)
GUICtrlSetFont(-1, 52, 800, 0, 'Tahoma')
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

GUICtrlCreateLabel('1. Halbzeit', 10, 130, 200, 30, $SS_CENTER)
GUICtrlSetFont(-1, 20, 800, 0, 'Tahoma')
GUICtrlSetColor(-1, 0x0066AA)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$h1stHalf = GUICtrlCreateLabel('00:00', 10, 160, 200, 50, $SS_CENTER)
GUICtrlSetFont(-1, 28, 800, 0, 'Tahoma')
GUICtrlSetColor(-1, 0xAAAAAA)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$hAddTime1 = GUICtrlCreateLabel('00:00', 10, 210, 200, 25, $SS_CENTER)
GUICtrlSetFont(-1, 16, 800, 0, 'Tahoma')
GUICtrlSetColor(-1, 0xFF2222)
GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

GUICtrlCreateLabel('Pause', 215, 130, 200, 30, $SS_CENTER)
GUICtrlSetFont(-1, 20, 800, 0, 'Tahoma')
GUICtrlSetColor(-1, 0x0066AA)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$hPause = GUICtrlCreateLabel('00:00', 215, 160, 200, 50, $SS_CENTER)
GUICtrlSetFont(-1, 28, 800, 0, 'Tahoma')
GUICtrlSetColor(-1, 0xAAAAAA)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

GUICtrlCreateLabel('2. Halbzeit', 430, 130, 200, 30, $SS_CENTER)
GUICtrlSetColor(-1, 0x0066AA)
GUICtrlSetFont(-1, 20, 800, 0, 'Tahoma')
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$h2ndHalf = GUICtrlCreateLabel('00:00', 430, 160, 200, 50, $SS_CENTER)
GUICtrlSetFont(-1, 28, 800, 0, 'Tahoma')
GUICtrlSetColor(-1, 0xAAAAAA)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$hAddTime2 = GUICtrlCreateLabel('00:00', 430, 210, 200, 25, $SS_CENTER)
GUICtrlSetFont(-1, 16, 800, 0, 'Tahoma')
GUICtrlSetColor(-1, 0xFF2222)
GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

GUICtrlCreateLabel('Gesamt-Spielzeit', 190, 250, 260, 30, $SS_CENTER)
GUICtrlSetColor(-1, 0x0066AA)
GUICtrlSetFont(-1, 20, 800, 0, 'Tahoma')
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$hAll = GUICtrlCreateLabel('00:00', 190, 280, 260, 60, $SS_CENTER)
GUICtrlSetFont(-1, 36, 800, 0, 'Tahoma')
GUICtrlSetColor(-1, 0xAAAAAA)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

$hStart = GUICtrlCreateButton('Starte' & @CRLF & '1. Halbzeit', 205, 360, 235, 60, $BS_MULTILINE)
GUICtrlSetFont(-1, 16, 800, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_Startbutton')
GUISetState()
AdlibRegister('_ShowDisplay', 200)

While Sleep(20)
WEnd

Func _End()
	AdlibUnRegister('_ShowDisplay')
	Exit
EndFunc   ;==>_End

Func _Startbutton()
	Switch $sStatus
		Case 'Start'
			GUICtrlSetColor($h1stHalf, 0x222222)
			GUICtrlSetColor($hAll, 0x222222)
			$iTimer = TimerInit()
			$sStatus = 'Pause'
			GUICtrlSetData($hStart, 'Halbzeit' & @CRLF & 'Pause')
			_ShowDisplay()
		Case 'Pause'
			GUICtrlSetColor($h1stHalf, 0xAAAAAA)
			GUICtrlSetColor($hAddTime1, 0xFFAAAA)
			GUICtrlSetColor($hPause, 0x222222)
			$iTimerPause = TimerInit()
			GUICtrlSetData($hStart, 'Starte' & @CRLF & '2. Halbzeit')
			$sStatus = '2nd'
			_ShowDisplay()
		Case '2nd'
			GUICtrlSetColor($h2ndHalf, 0x222222)
			GUICtrlSetColor($hPause, 0xAAAAAA)
			GUICtrlSetData($hStart, 'Spiel' & @CRLF & 'beenden')
			$iTimer = TimerInit()
			$sStatus = 'End'
			_ShowDisplay()
		Case 'End'
			GUICtrlSetColor($h1stHalf, 0xAAAAAA)
			GUICtrlSetColor($h2ndHalf, 0xAAAAAA)
			GUICtrlSetColor($hAddTime2, 0xFFAAAA)
			GUICtrlSetData($hStart, 'Anzeige' & @CRLF & 'zurcksetzen')
			$sStatus = 'Reset'
		Case 'Reset'
			GUICtrlSetState($hAddTime1, $GUI_HIDE)
			GUICtrlSetState($hAddTime2, $GUI_HIDE)
			GUICtrlSetColor($hAddTime1, 0xFF2222)
			GUICtrlSetColor($hAddTime2, 0xFF2222)
			GUICtrlSetData($h1stHalf, '00:00')
			GUICtrlSetData($h2ndHalf, '00:00')
			GUICtrlSetData($hPause, '00:00')
			GUICtrlSetData($hAll, '00:00')
			GUICtrlSetColor($hAll, 0xAAAAAA)
			GUICtrlSetData($hStart, 'Starte' & @CRLF & '1. Halbzeit')
			$sStatus = 'Start'
	EndSwitch
EndFunc   ;==>_Startbutton

Func _ShowDisplay()
	Local $iTmp
	Switch $sStatus
		Case 'Pause'
			$iTmp = TimerDiff($iTimer)
			GUICtrlSetData($h1stHalf, _MyTicksToTime($iTmp))
			GUICtrlSetData($hAll, _MyTicksToTime($iTmp))
			If $iTmp > 2700000 Then
				GUICtrlSetState($hAddTime1, $GUI_SHOW)
				GUICtrlSetData($hAddTime1, _MyTicksToTime($iTmp - 2700000))
			EndIf
		Case '2nd'
			GUICtrlSetData($hPause, _MyTicksToTime(TimerDiff($iTimerPause)))
		Case 'End'
			$iTmp = TimerDiff($iTimer)
			GUICtrlSetData($h2ndHalf, _MyTicksToTime($iTmp))
			GUICtrlSetData($hAll, _MyTicksToTime($iTmp + 2700000))
			If $iTmp > 2700000 Then
				GUICtrlSetState($hAddTime2, $GUI_SHOW)
				GUICtrlSetData($hAddTime2, _MyTicksToTime($iTmp - 2700000))
			EndIf
	EndSwitch
	GUICtrlSetData($hTime, @HOUR & ':' & @MIN & ':' & @SEC)
	If @MDAY & '.' & @MON & '.' & @YEAR <> $sDate Then
		$sDate = @MDAY & '.' & @MON & '.' & @YEAR
		GUICtrlSetData($hDate, $sDate)
	EndIf
EndFunc   ;==>_ShowDisplay

Func _MyTicksToTime($iTicks)
	Local $iHours, $iMins, $iSecs = Int($iTicks / 1000)
	$iMins = Int($iSecs / 60)
	$iSecs = Mod($iSecs, 60)
	Return StringFormat('%02i:%02i', $iMins, $iSecs)
EndFunc   ;==>_MyTicksToTime
